Last minute notes on ExtenDOS Gold
----------------------------------
Version:        3.3C
Dated:          6 april 2000

Program versions on this diskette:
CD.BOS          3.3B
CDAUDIO.PRG     3.3B
CDAUDIO.RSC     3.3B
EXTENDOS.PRG    3.3
EXTINFO.PRG     3.3B
INSTALL.APP     3.3B
INSTALL.RSC     3.3B
SESSION.CPX     1.0
UNIDRIVE.DOS    3.3C

Other files on this diskette:
EXTENDOS.CNF    An example configuration file
READ.ME         This very text file


New features that are not documented in the manual
==================================================
Drivers
-------
1. Added support for accessing audio CD tracks as WAV files as well
   as PRG files; this allows audio tracks to be copied to a WAV file
   using any standard copying method such as the desktop.  The list
   of pseudo-files now accessible on an audio CD is:
      DISK.PRG TRACK01.PRG TRACK01.WAV ... TRACK99.PRG TRACK99.WAV
   *IMPORTANT* Certain devices (e.g. the Yamaha 6416) will return
   CDDA data (audio data) out of order when doing very large reads,
   such as caused by copying a pseudo-WAV file from the desktop!  If
   you have this problem, you can circumvent it by using the "limit
   I/O length" option (see below).

2. Added SCSIDRV support.  This allows ExtenDOS Gold to access busses
   for which it does not have built-in support: for example, the IDE
   bus on the Falcon, or the SCSI bus available via a plug-in board
   on the Hades.  In order for this to work, a driver that supports
   the SCSIDRV protocol on your system must be available; check your
   system documentation to see if one is supplied.  If not, you may
   wish to investigate the HDDRIVER hard disk driver (by Uwe Seimet),
   which provides SCSIDRV support on many systems.
   *NOTE* If the SCSIDRV interface is available, ExtenDOS Gold will
   use it by default for ALL devices, including those on the standard
   Atari ACSI and SCSI busses.  In order to use the builtin support
   for ACSI and SCSI in these circumstances, you must specify "No"
   for the "use SCSIDRV" option (S=N switch).  See below for more
   information.

3. Added command-set support for ATAPI revisions 1.2 & 2.6, both
   CD-ROM & CD-R(W).  This means that most modern ATAPI/IDE CD
   devices should work on systems with the appropriate hardware
   (e.g. Falcon or Milan).
   *NOTE* In order to send the commands across the IDE bus, ExtenDOS
   Gold uses the SCSIDRV protocol.  Therefore an appropriate SCSIDRV
   driver must be installed for the bus in question.

4. The following additional devices are supported:
    CD recorders:
     . Panasonic 7502
     . Plextor PX4/12, PX8/20
     . Ricoh 7060S
     . TEAC 50S, 55S
    CD-ROM drives:
     . Nakamichi MJ-5.16S
     . TEAC CD-50, 532S
   The default for otherwise unrecognised TEAC SCSI-2 devices has
   been changed to be the same as the TEAC 532S.  The default for
   Yamaha CD-RWs is now the same as other SCSI3/MMC devices.
   In addition, SCSI-3/MMC compatibility has been improved, so
   more SCSI-3/MMC-compliant drives should work automatically.

5. Added support for the "Rock Ridge Interchange Protocol" (RRIP),
   which is a method for storing long / lowercase filenames on
   ISO9660 CD-ROMs.  ExtenDOS Gold will use RRIP information (if
   present) to provide filenames to MiNT/MagiC extended filesystem
   calls, subject to the "use RRIP info" option (X= switch).  See
   below for more information.

6. Added "force uppercase names" option to UNIDRIVE.DOS:
     . U=   controls the case of filenames returned by the
            Fsfirst()/Fsnext() filesystem calls; it applies to
            filenames from standard ISO9660, Joliet, or RRIP.
            U=Y means force uppercase; U=N means leave as-is.
            The default is U=N.

7. Added "use RRIP info" option to UNIDRIVE.DOS:
     . X=   controls use of the RRIP extension information.
            X=Y means use the RRIP data if available; X=N means
            don't use RRIP.  The default is X=Y.

8. Changed the default for "use SCSI arbitration" in CD.BOS from
   "No" to "Yes" (default for A= switch changes from A=N to A=Y);
   this change was made in v3.3. Therefore, in v3.3 (and later),
   SCSI arbitration will be attempted first during bootup _unless_
   A=N is specified.  This has two benefits:
     . CD devices that _require_ arbitration, such as most CD
       recorders, will not be subject to a bus reset (following
       a timeout trying to access them with arbitration off),
       which causes some devices, such as the Ricoh 7060, to
       stay in the 'becoming ready' state so long that CD.BOS
       cannot identify them as mmc-compliant
     . since all current (and most older) CD devices support
       arbitration, this will speed up boot time marginally
       in most cases
   There is a corresponding change in INSTALL.APP.  Note that
   even if you specify A=N, SCSI arbitration will be used (if
   possible) for devices that report themselves as SCSI-2
   devices, since SCSI-2 implies support for arbitration.

9. Added "parity check" option to CD.BOS:
     . C=   controls input SCSI bus parity checking: C=Y means
            check input parity; C=N means don't check it.  The
            default is C=N, for compatibility with earlier
            versions of ExtenDOS.

10. Added "fast i/o" option to CD.BOS:
     . F=  controls the minimum time between two I/Os on the ACSI
           or SCSI bus: F=Y means that the minimum time is zero,
           F=N means the minimum time is 2 clock ticks (10 msecs).
           The default is F=N, for compatibility with earlier
           versions of ExtenDOS.
   The F=Y switch was introduced to allow the user to maximise the
   throughput of the ACSI and SCSI busses.  It may not work with
   all devices (particularly on the ACSI bus); however, it does
   increase SCSI i/o throughput enough to allow 6X recording to a
   CD-R, using a very fast IDE drive on an accelerated Falcon.

11. Added "limit I/O length" option to CD.BOS:
     . K=  limits the size of data transfers: K=Y means limit
           the data transfer length to 64K; K=B means limit the
           length to 25% of the device's buffer size (if known;
           otherwise treat as K=Y); K=N means don't limit the
           length.  The default is K=N.
   The K= switch provides a way of bypassing firmware bugs that are
   associated with large data transfers.  As examples, the following
   specific bugs can be bypassed:
     . the Acer 2x2x6 CD-RW recorder hangs on large writes; fixed
       by specifying K=Y
     . the Yamaha 6416 returns CDDA data out of order when doing
       a multi-megabyte read (e.g. when using the desktop to copy
       an audio CD track to a hard disk); fixed by specifying K=B
       (which for this device allows 500KB data transfers).

12. Added "disable DMA transfer" option to CD.BOS:
     . M=   controls DMA transfer: M=Y means do DMA transfer if
            possible, M=N means don't.  The default is M=Y.
   *IMPORTANT* this feature is intended to provide a bypass if
   you are experiencing DMA hardware problems; do NOT use this
   in any other circumstance, as it will slow down data transfers
   considerably!

13. Added "use SCSIDRV" option to CD.BOS:
     . S=  controls SCSIDRV usage: S=Y means use SCSIDRV if
           available, S=N means don't.  The default is S=Y.
   This option only applies to devices on the standard Atari ACSI and
   SCSI busses, since they are the only busses for which ExtenDOS
   Gold has builtin support.  Other busses are always accessed via
   SCSIDRV.

14. Improved coordination with HDDRIVER when ExtenDOS Gold is NOT
   using HDDRIVER's SCSIDRV routines: ExtenDOS Gold's own SCSI I/O
   routines now work properly with HDDRIVER's target device code.

15. If NVRAM exists, the default value for the host SCSI id is now
   taken from the appropriate offset in NVRAM.  If NVRAM does not
   exist, the default value is 7 (as it was previously).  As before,
   the default may be overridden via the appropriate global option
   in INSTALL.APP.

16. When adding ExtenDOS Gold's cookie ('EPro'), a check is made to
   see if the cookie jar has previously overflowed; if so, a warning
   message is issued.  This was prompted by a bug in VIDELITY that
   can cause the cookie jar to overflow.

17. EXTENDOS.PRG now has the fastload bit set, for faster AUTO
   folder processing.


CDaudio
-------
1. The user interface has been rewritten to use multiple windows, with
   a proper menu bar and a look-and-feel similar to Anodyne Software's
   CD recording programs.  The main windows are the Play window, the
   Record window, and the Preferences window; there is also an About
   window containing program version and copyright information, and a
   Progress window that is displayed while recording.  When CDaudio
   is run as a program, windows are selected via the menu bar, or by
   keyboard shortcuts.  When run as a desk accessory, opening the
   accessory causes the Play window to be displayed; other windows
   are accessible via a set of buttons in the lower left corner of
   the main window (note that these buttons are only displayed when
   CDaudio is run as an accessory).

2. The Play and Record windows are similar to the ones in previous
   versions, except that the 'Fuller' gadget (in the upper right
   corner of the window) is used to switch between displaying the
   full window and displaying the title bar only.

3. The Preferences window controls all preferences, including drive
   selection: the drive selection arrows have been removed from the
   Play window.  The default values for recording are also set here:
   mode, resolution, frequency, and output file type.
   The following new options are available:
     . the default path for extracted files
     . an explicit option to remove silence from between tracks
       or not (previously it was always removed)
     . the size of the recording buffer to be used when running
       as an accessory; this ONLY applies to the accessory (when
       running as a program, the size of the buffer is determined
       dynamically)
   *IMPORTANT*
   By default, the accessory recording buffer size is zero in order
   to minimise the amount of memory used by the accessory.  A BUFFER
   SIZE OF ZERO DISABLES RECORDING AND ACCESS TO THE RECORD WINDOW.
   Unless you have lots of memory and can afford to use a buffer
   size of at least 50K, we recommend that you do not use the
   accessory for recording.

4. When playing from the start of a track, playback is started one
   second before the actual start of the track, to avoid a reported
   "cut-off" in the sound at the start of a track.


Install
-------
1. Added SCSIDRV support, including new dialogs.  In order to handle
   multiple busses (the SCSIDRV protocol supports up to 32), the
   "ACSI/SCSI DMA id assignment" dialog that, in previous versions,
   showed the status of all possible IDs on the ACSI & SCSI busses
   has been replaced by two dialogs.  The initial dialog displayed
   in place of the "ACSI/SCSI DMA id assignment" dialog is the bus
   summary dialog.  This contains one line per available bus showing
   the bus name, the number of CD devices currently allocated on the
   bus, and the drive letters assigned to devices on that bus.
   Clicking on the "Select" button for a bus brings up the device id
   assignment dialog for that bus, with one line per possible ID,
   showing the inquiry data from that id and the device letter(s)
   assigned to it.

2. Added support for new and revised switches in v3.2 & v3.3:
     . A=  use SCSI arbitration
     . C=  controls SCSI parity checking
     . F=  controls 'fast I/O'
     . K=  limits data transfer length
     . M=  controls use of DMA for ACSI/SCSI
     . S=  controls use of SCSIDRV support
     . U=  forces uppercase for file/folder names
     . X=  controls use of Rock Ridge data
   These switches are set or cleared by buttons selectable in the
   "Advanced options" dialog; for further information about each
   option, press the "Help" button on the "Advanced options" dialog,
   or refer to the descriptions under 'Drivers' (above).

3. Added support for multi-LUN devices where LUN 0 is NOT a CD device
   (e.g. Panasonic Phasewriter).

4. Changed "Install new version" dialogs to allow installation from
   any path, not just from a floppy drive.  The source installation
   path defaults to the folder that INSTALL.APP was run from.

5. Changed "Install new version" logic to handle temporarily-deactivated
   target files in a smart fashion, so that we don't upset boot managers
   by having e.g both CDAUDIO.ACC & CDAUDIO.ACX in the root.

6. Clarified descriptive text displayed in the file selector.


ExtInfo
-------
1. ExtInfo now uses multiple output filenames, to avoid overwriting
   one created previously.  The name used is the first one of the 
   format EXTINFO?.TXT (? is 0-9, A-Z) that is available.  If all
   these names are in use, ExtInfo will revert to the old method,
   using EXTINFO.TXT and overwriting any existing file of that name.

2. ExtInfo uses a (new) EXTINFO.INF file to save the user name data,
   so that you only need to enter it once; the next time you run
   ExtInfo, the name/address dialog will be filled in with the data
   that you entered previously.



Known restrictions and incompatibilities
========================================
1. IMPORTANT: when using CDaudio to play audio CDs on your CD-ROM
   drive, all audio output is from the CD-ROM drive itself, _not_
   through your system's speaker(s).  Most CD-ROM drives provide
   output sockets at the front (headphone) and rear (RCA jacks or
   other connector).  In order to hear the output from your CD-ROM
   drive, you _must_ connect one or other of these to your audio
   equipment.

2. NeoDesk users: if you get a message that "data on the disk is
   corrupted or damaged" when you double click on the CD-ROM drive
   icon, or open a folder, turn off the option 'check for
   executable bootsector' in NeoDesk/Set Preferences/More.

3. Alternate RAM users: EXTENDOS.PRG must be loaded into ST RAM for
   correct operation.  If you have a system with alternate RAM,
   such as the TT030, do NOT set the program flags to load it into
   alternate RAM.

4. When an ISO9660 (or High Sierra) CD-ROM is mounted on a CD-ROM
   drive, it does NOT have a low-level file structure like a hard
   disk partition.  Programs that expect all devices to look like
   a hard disk partition will usually issue an error message such
   as "can't access BPB" or "unrecognized boot sector".  This does
   not indicate a problem with the device.



Acknowledgements
================
I'd like to thank the beta testers who helped me with testing
ExtenDOS Gold.  If you like it, it's due in large part to these
people (it's also a nice example of international cooperation, with
testers from Canada, Germany, Italy, UK and USA).  So, thanks to:
     David Acklam
     Erich Arning
     Mauro Brollo
     Mike Farrington
     Claude Labelle
     Shiuming Lai
     Torsten Lang
     Robert Schaffner

Since ExtenDOS Gold is based on ExtenDOS Pro (and before that,
ExtenDOS), I also owe thanks to all the people who helped me
test those programs on all kinds of hardware and software:
     Kim Andersen
     Lee Benjamin
     Danny Bhabuta
     Daron Brewood
     Alexander Clauss
     Ray Collins
     Jerry Coppess
     Steve Deitz
     Al Fasoldt
     Gary Fuhrman
     Steve Hammond
     Graham Irvine
     Bertil Jagard
     Rob Perry
     Doug Steever
     Frank Tobiassen
     Dale Wenzelburger



If you have a problem
=====================
Please read the manual first, especially the "Troubleshooting" section.
If you still can't figure out what's wrong, you may contact Anodyne
Software for help via telephone, electronic mail, or regular mail.

If you do so, please be prepared to provide the following information:
   . your ExtenDOS Gold serial number (from the distribution diskette)
   . a listing of your EXTENDOS.CNF configuration file
   . a copy of the EXTINFO.TXT file produced by EXTINFO.PRG.  This
     is particularly important if ExtenDOS Gold appears to install
     correctly, but you have problems accessing data or audio CDs.



Roger Burrows
----------------------------------------------------------------------------
Email:    anodyne@cyberus.ca
Web site: http://www.cyberus.ca/~anodyne
Mail:     Anodyne Software, 6 Cobbler Court, Ottawa, Ontario K1V 0B8, CANADA
Phone:    (613) 523-7498
----------------------------------------------------------------------------
